#include "canvas/Canvas.hpp"

void Canvas::init(int size)
{
  backGround.init(size);
  tree.init(size);
}

void Canvas::newGen(RenderTexture2D &target, Dna *dna)
{
  BeginTextureMode(target);
  ClearBackground(WHITE);

  backGround.draw(dna);
  tree.draw(dna);

  EndTextureMode();
}

bool Canvas::tick(RenderTexture2D &target)
{
  BeginTextureMode(target);
  bool ret = tree.tick();
  EndTextureMode();
  return ret;
}

void Canvas::deinit()
{
  backGround.deinit();
}
